<html
    xmlns:f="http://typo3.org/ns/TYPO3/CMS/Fluid/ViewHelpers"
    xmlns:be="http://typo3.org/ns/TYPO3/CMS/Backend/ViewHelpers"
    xmlns:sv="http://typo3.org/ns/T3graf/Smartverein/ViewHelpers"
    xmlns:core="http://typo3.org/ns/TYPO3/CMS/Backend/ViewHelpers"
    data-namespace-typo3-fluid="true">

<f:layout name="Default" />

<f:section name="Content">
    <f:flashMessages />

    <div class="btn-toolbar" role="toolbar" aria-label="" style="margin-bottom: 10px;">
        <div>
            <be:link.newRecord class="btn btn-warning btn-md t3js-editform-close" title="ll:add new address" table="tx_smartverein_domain_model_addressbook" returnUrl="{f:be.uri(route: 'SmartvereinSvtools_SmartvereinAddresses')}" pid="{storagePid}">
                <i class="fa-solid fa-user-plus"></i> <f:translate key="labels.button.newAddress"/>
            </be:link.newRecord>
        </div>

<div  class="ms-auto datatable-right-buttons-parent">
    <div class="dropdown datatable-right-buttons-child" id="table-button">
        <button class="btn btn-default btn-md dropdown-toggle table-controls-button"  type="button" id="adaptColumnsButton" data-bs-toggle="dropdown"  aria-expanded="false">
            <i class="fa-solid fa-wrench"></i>&nbsp;<f:translate key="labels.button.adaptColumns"/>
        </button>
        <ul class="controls-dropdown-box dropdown-menu"  id="controls-dropdown-menu" aria-labelledby="adaptColumnsButton">

        </ul>
    </div>

    <div  class="datatable-right-buttons-child">
        <a class="btn btn-default btn-md dropdown-toggle disabled" href="#" role="button" data-bs-toggle="dropdown" aria-expanded="false">
            <f:translate key="labels.button.actions"/>
        </a>

        <ul class="dropdown-menu">
            <li><a class="dropdown-item" href="#"><i class="fa-solid fa-wrench"></i>&nbsp;Adapt table</a></li>
            <li><hr class="dropdown-divider"></li>
            <li><a class="dropdown-item" href="#"><i class="fa-solid fa-file-import"></i>&nbsp;Import CSV</a></li>
            <li><hr class="dropdown-divider"></li>
            <li><a class="dropdown-item" href="#"><i class="fa-solid fa-file-pdf"></i>&nbsp;Export PDF</a></li>
            <li><a class="dropdown-item" href="#"><i class="fa-solid fa-file-excel"></i>&nbsp;Export Excel</a></li>
            <li><a class="dropdown-item" href="#"><i class="fa-solid fa-file-csv"></i>&nbsp;Export CSV</a></li>
            <li><a class="dropdown-item" href="#"><i class="fa-solid fa-address-card"></i>&nbsp;Export vCards</a></li>
        </ul>
    </div>
</div>



    </div>
        <table id="addresses" class="tx_smartclub table table-striped">
            <thead>
            <tr>
                <th><f:translate key="address.logo"/></th>
                <th><f:translate key="address.type"/></th>
                <th><f:translate key="address.address" /></th>
                <th data-sortable="false"><f:translate key="address.contacts" /></th>
                <th data-sortable="false"><f:translate key="address.note" /></th>
                <th data-sortable="false"></th>
            </tr>
            </thead>
            <tbody>
            <f:for each="{addresses}" as="address">
                <tr>
                    <td>
                                                  <f:if condition="{address.image}">
                                <f:image image="{address.image}" height="50" />
                            </f:if>
                                          </td>
                    <td>

    <f:switch expression="{address.type}">
        <f:case value="0"><small class="badge bg-info"><f:translate key="address.type.0" /></small></f:case>
        <f:case value="1"><small class="badge bg-success"><f:translate key="address.type.1" /></small></f:case>
        <f:case value="2"><small class="badge bg-success"><f:translate key="address.type.2" /></small></f:case>
        <f:case value="3"><small class="badge bg-warning"><f:translate key="address.type.3" /></small></f:case>
        <f:case value="4"><small class="badge bg-primary"><f:translate key="address.type.4" /></small></f:case>
        <f:case value="5"><small class="badge bg-danger"><f:translate key="address.type.5" /></small></f:case>
        <f:case value="6"><small class="badge bg-danger"><f:translate key="address.type.6" /></small></f:case>
        <f:case value="7"><small class="badge bg-danger"><f:translate key="address.type.7" /></small></f:case>
        <f:defaultCase></f:defaultCase>
    </f:switch>


                    </td>
                    <td>{address.companyName}<br/>
                        {address.department}<br/>
                        <br/>
                        {address.contactPerson}<br/>
                        {address.position}<br/>
                        {address.street}<br/>
                        {address.zip} {address.city}<br/>
                        <sv:local.state uid="{address.state}"/>
                        <sv:local.country uid="{address.country}"/></td>
                        </td>
                    <td>
                        <f:if condition="{address.contacts}">
                            <f:for each="{address.contacts}" as="contact">
                                <f:switch expression="{contact.type}">
                                    <f:case value="1"><i class="fa-regular fa-envelope"></i> {contact.contact}</f:case>
                                    <f:case value="2"><i class="fa-solid fa-phone"></i> {contact.contact}</f:case>
                                    <f:case value="3"><i class="fa-solid fa-mobile-screen-button"></i> {contact.contact}</f:case>
                                    <f:case value="5"><i class="fa-solid fa-square-envelope"></i> {contact.contact}</f:case>
                                    <f:case value="6"><i class="fa-solid fa-square-phone"></i> {contact.contact}</f:case>
                                    <f:case value="7"><i class="fa-solid fa-globe"></i> {contact.contact}</f:case>
                                    <f:defaultCase></f:defaultCase>
                                </f:switch>
                                <br/>
                            </f:for>
                        </f:if>
                    </td>
                    <td>
                        <f:format.html>
                        <f:format.crop maxCharacters="50">
                            {address.note}
                        </f:format.crop>
                        </f:format.html>
                    </td>
                    <td>
                        <f:comment>
                            <f:link.action action="beShowaddressDetails" arguments="{address: address}" class="btn btn-success" title="LL:Show address details"><i class="fa-regular fa-address-card"></i></f:link.action>
                        </f:comment>

                        <be:link.editRecord class="btn btn-success" title="ll:edit address" uid="{address.uid}" table="tx_smartverein_domain_model_addressbook" returnUrl="{f:be.uri(route: 'SmartvereinSvtools_SmartvereinAddresses')}">
                            <i class="fa-solid fa-user-pen"></i>
                        </be:link.editRecord>
                        <f:comment>
                            <f:link.action action="beShowaddressDetails" arguments="{address: address}" class="btn btn-danger" title="LL:Delete address"><i class="fa-solid fa-trash-can"></i></f:link.action>
                        </f:comment>
                        </td>

                </tr>
            </f:for>
            </tbody>
        </table>


<f:comment>
    addaddress Modal
</f:comment>
    <div class="modal fade" id="addNewaddressModal" tabindex="-1" aria-labelledby="addNewaddressModalLabel" aria-hidden="true">
        <div class="modal-dialog" style="width: 37.5rem;">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="addNewaddressModalLabel">Icon LL:Create a new address</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>

                <f:form action="createNewaddress" name="newaddress" object="{newaddresses}">
                    <div class="modal-body">
                        <h4>LL:Login data</h4>
                        <small><em>Login email address <u>or</u> username for login - unique</em></small>
                        <div class="form-group has-feedback">
                            <input type="email" class="form-control" id="loginEmail" name="email" placeholder="* Login email address or user name for login" value="">
                            <!-- <span class="far fa-fw fa-envelope form-control-feedback g"></span> -->
                        </div>
                        <label><input type="checkbox" name="sendEmail"> Send invitation with a link to choose a password</label>		<br>
                        <h4>LL:address data</h4>
                        <div class="form-group has-feedback">
                            <input class="form-control" name="addressId" placeholder="address number" value="311">
                            <!-- <span class="far fa-fw fa-tag form-control-feedback"></span> -->
                        </div>
                        <div class="form-group has-feedback">
                            <input type="text" class="form-control datemask hasDatepicker" name="dateJoined" placeholder="Date of joining" id="dp1677836840407">
                            <!-- <span class="far fa-fw fa-calendar-alt form-control-feedback"></span> -->
                        </div>
                        <hr>
                        <h4>LL:Master data</h4>
                        <div id="addaddressContactMessage" style="display: none;">
                            <em>Data are taken from contact</em>
                        </div>
                        <div id="addaddressContactForms">
                            <f:comment>
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group has-feedback">
                                        <input type="text" list="salutation_selection" class="form-control" name="salutation" placeholder="Formal address">
                                        <datalist id="salutation_selection">
                                            <option value="Herr"></option>
                                            <option value="Frau"></option>
                                        </datalist>

                                        <!-- <span class="far fa-fw fa-venus-mars form-control-feedback"></span> -->
                                    </div>
                                </div>
                            </div>
                            </f:comment>
                            <div class="form-group has-feedback">
                                <f:form.textfield class="form-control success" property="firstname" id="firstname" placeholder="* First name"/>
                                <!--input type="text" class="form-control success" name="firstName" placeholder="* First name"-->
                                <!-- <span class="far fa-fw fa-user form-control-feedback g"></span> -->
                            </div>
                            <div class="form-group has-feedback">
                                <f:form.textfield class="form-control" property="surname" id="surname" placeholder="* Surname"/>
                                <!--input type="text" class="form-control" name="familyName" placeholder="* Surname"-->
                                <!-- <span class="far fa-fw fa-users form-control-feedback g"></span> -->
                            </div>
                        </div>
                        <strong>LL:After the new address has been created further data can be added.</strong>

                    </div>

                    <f:comment>
                        <f:link.action action="new" class="btn btn-default">New addresses</f:link.action>
                    </f:comment>


                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-bs-dismiss="modal">Close</button>
                    <f:form.submit value="ll:Save address" class="btn btn-danger"/>
                </div>
                </f:form>
            </div>
        </div>
    </div>

    <f:comment>
        JavaScript for Datatables
    </f:comment>
<f:asset.script identifier="addresstable-inline">
    require([
    'simpledatatables'
    ], function (simpledatatables) {

    dataTable = new simpledatatables.DataTable("#addresses",{
    columns: [
    // Column address logo
    { select: 0, sortable:false, hidden: true },

    // Column address Type
    { select: 1, sortable:false},

    // Column Address
    { select: 2, sort: "asc" },

    // Contact
    { select: 3, sortable:false},

    // Column note
    { select: 4, sortable:false, hidden: true },

    // Column action buttons
    { select: 5, sortable:false, searchable:false},
    ],


    labels: {
    placeholder:"<f:translate id="table.address.placeholder" />",
    searchTitle:"<f:translate id="table.address.searchTitle" />",
    perPage:"<f:translate id="table.address.perPage" />",
    noRows:"<f:translate id="table.address.noRows" />",
    info:"<f:translate id="table.address.info" />",
    noResults:"<f:translate id="table.address.noResults" />"
    }
    });

    var inputs = [], visible = [], hidden = [];
    var checkboxes = document.getElementById("controls-dropdown-menu");
    var tbutton = document.getElementById("table-button");
    //dataTable.headings = window.headings;
    function setCheckboxes() {
    inputs = [];
    visible = [];
    checkboxes.innerHTML = "";
    var fragment = document.createDocumentFragment();
    var isVisible = false;

    document.onclick = function(e){
    if(!tbutton.contains(e.target.parentNode)){
    checkboxes.style.cssText = "display:none;";
    isVisible = false;
    }
    };

    tbutton.onclick = function(e){
    if(checkboxes.contains(e.target)){
    return true;
    }
    if(!isVisible){
    checkboxes.style.cssText = "display:block;";
    isVisible = true;
    }else{
    checkboxes.style.cssText = "display:none;";
    isVisible = false;
    }
    };
    var indx = 0;
    [].forEach.call(dataTable.data.headings, function(heading, i) {

    if (heading.data !== '') {
    var checkbox = document.createElement("li");
    checkbox.className = "dropdown-item";
    var input = document.createElement("input");
    input.type = "checkbox";
    input.id = "checkbox-" + i;
    input.name = "checkbox";
    input.className = "form-check-input"
    var label = document.createElement("label");
    label.htmlFor = "checkbox-" + i;
    label.className = "form-check-label datatable-checkbox-label";
    label.appendChild(

    document.createTextNode(heading.data || heading.innerText)
    );

    // IE 8 supports `Object.defineProperty` on DOM nodes so no p!
    if (Object.defineProperty) {
    Object.defineProperty(input, "idx", {
    value: i,
    writable: false,
    configurable: true,
    enumerable: true
    });
    } else if (input.__defineGetter__) {
    input.__defineGetter("idx", function () {
    return i;
    })
    }
    if (dataTable.columns.visible(indx)) {
    input.checked = true;
    visible.push(i);
    } else {
    if (hidden.indexOf(i) < 0) {
    hidden.push(i);
    }

    }

    checkbox.appendChild(input)
    checkbox.appendChild(label)

    fragment.appendChild(checkbox);

    inputs.push(input);
    }
    indx++;
    });

    [].forEach.call(inputs, function(input, i) {

    input.onchange = function(e) {
    if ( input.checked ) {
    hidden.splice(hidden.indexOf(input.idx), 1);
    visible.push(input.idx);
    } else {
    visible.splice(visible.indexOf(input.idx), 1);
    hidden.push(input.idx);
    }

    updateColumns();
    };
    });

    checkboxes.appendChild(fragment);
    }

    function updateColumns() {
    try {
    dataTable.columns.show(visible);
    dataTable.columns.hide(hidden);
    } catch(e) {
    console.log(e);
    }
    }

    setCheckboxes();
    return dataTable;
    });
</f:asset.script>
</f:section>
</html>
